# advancedmaths

## Introduction

This Python package, `advancedmaths`, provides a collection of advanced mathematical functions covering various areas such as algebra, statistics, arithmetic, geometry, and factors.

## Installation

You can install `advancedmaths` via pip:

```bash
pip install advancedmaths
```

# Usage

## Algebra

```python
from advancedmaths.algebra import exponentiation, logarithm
```

## Statistics

```python
from advancedmaths.statistics import mean, median, mode
```

## Arithmetic

```python
from advancedmaths.arithmetic import add, subtract, multiply, divide, factorial
```

## Geometry

```python
from advancedmaths.geometry import square_perimeter, square_area, rectangle_perimeter, rectangle_area, circle_perimeter, circle_area, cube_volume, cube_surface_area, sphere_volume, sphere_surface_area
```

## Factors

```python
from advancedmaths.factors import prime_factors
```

# License

## Copyright (c) 2024-present Ananyo Bhattacharya

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

**THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.**
